#include "LoopEngine/Global.h"
#include "LoopEngine/GameObject/GOParticleEmitter.h"
#include "raymath.h"

LE::GOParticleEmitter::GOParticleEmitter(const std::string& InImageFileName, const std::string& InEmitterName)
	:GOSimpleTexture(InImageFileName,InEmitterName)
{
	_TimerContinuousEmission.PlayOnce(false);
	_TimerContinuousEmission.SetActive(false);
	_TimerContinuousEmission.SetCallback([this]() {
		Play();
		});
}

void LE::GOParticleEmitter::Play()
{
	///////////////////////////
	//7) Appeler Play() (testable avec le bouton) met TOUJOURS un burst.
	//Ce n'est pas tout: dans ParticleEmitterParam, reprer les paramtres pour le no 7).
	//Si _IsEmittingContinuously est  vrai, on dmarre le timercallback (configur en PlayOnce)
	//et le temps d'appel sera alatoire selon _RangeNextBurstTime.
	//Testez la fume aprs avec Play() et Stop()

	//Rendez-vous dans LE::GOParticleEmitter::EmitOne()
	///////////////////////////
}

void LE::GOParticleEmitter::Stop()
{
	_TimerContinuousEmission.SetActive(false);
}

void LE::GOParticleEmitter::KillAll()
{
	_ParticleStates.clear();
}

void LE::GOParticleEmitter::EmitOne()
{
	ParticleState state;
	state._LifeTime = 0.f;
	state._Position = GetWorldPosition();

	///////////////////////////
	//5) Toutes les valeur de ParticleEmitterParam du no 5 donnent l'tat initial des particules.
	// Utilisez GetRandomFloat et GetRandomVector dans Global.h
	// Vitesse linaire
	// Dure de vie
	// Vitesse de rotation
	// Acclration linaire (exception - valeur fixe non alatoire)
	//Allez ensuite dans LE::GOParticleEmitter::EmitBurst()
	///////////////////////////

	///////////////////////////
	//8) La position de la particule doit tre mise alatoirement dans la boite de collision
	//Aidez-vous de GetRandomVector de Global.h pour initialiser sa position
	//Testez ensuite la fume, elle sera mise dans un carr au lieu d'un point.
	//Rendez-vous dans ParticleEmitterParamRain()
	///////////////////////////

	_ParticleStates.emplace_back(state);
}


void LE::GOParticleEmitter::EmitBurst()
{
	///////////////////////////
	//6) Dans ParticleEmitterParam, section no6), utilisez le paramtre pour mettre un nombre de particule alatoire.
	//Testez avec le bouton EmitBurst()

	//Allez dans LE::GOParticleEmitter::Play()
	///////////////////////////
}

void LE::GOParticleEmitter::PreUpdate()
{
	const float delta = GetFrameTime();
	_TimerContinuousEmission.Update(delta);

	//Efface les particules dont la dure de vie est termine.
	_ParticleStates.erase(
		std::remove_if(_ParticleStates.begin(), _ParticleStates.end(), [](LE::GOParticleEmitter::ParticleState p) {
				return p._LifeTime > p._DieTime;
			}),
		_ParticleStates.end()
	);

	for (auto& p : _ParticleStates)
	{

		///////////////////////////
		//3) Bougez avec WASD et utilisez le bouton EmitOne() pour tester. Une petite particule devrait apparatre
		//Vous devez mettre  jour l'tat de la particule ici. Le rsultat final doit tre comme le vido.
		//Liftetime:
		//Rotation:
		//Vitesse
		//Position
		///////////////////////////

		///////////////////////////
		//4) Dans ParticleEmitterParam, les variable de no 4) vous donnerons les points de dpart et d'arrive de la grosseur et de la couleur.
		//Calculer  combien de % la vie de la particule est rendue avant.

		//Grosseur - Utiliser la fonction Lerp de Raylib
		//Couleur - Utiliser ColorLerp de Raylib - 
		//Rendez-vous dans LE::GOParticleEmitter::EmitOne()
		///////////////////////////
	}
}

void LE::GOParticleEmitter::Draw2D()
{
	GameObject::Draw2D();
	for (auto& p : _ParticleStates)
	{
		Rectangle destination{p._Position.x,p._Position.y,p._Size,p._Size };
		const float center = p._Size * 0.5f;
		Vector2 origin{ center ,center };
		if (IsTextureValid(_Texture))
		{
			Rectangle source{0,0,_Texture.width,_Texture.height};
			DrawTexturePro(_Texture, source, destination, origin,p._Rotation, p._Color);
		}
		else
		{
			DrawRectanglePro(destination, origin, p._Rotation, p._Color);
		}
	}
}
